/**
*@ author Sebastian Seyrich, Markus Mattes
*/

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;
import java.lang.Exception;
/**
*The serverprogram: 
*A list of games will be established and administrated here
*/
public class GameServer extends UnicastRemoteObject implements GameServerInterface{

	private Game game; //ist also ersteinmal die einelementige statische Liste
	private Vector gameList;
	
	public GameServer() throws RemoteException{
		gameList = new Vector();
		game = new Game(this);
		gameList.addElement(game);
	}


	/**
	*@ return a new game
	*establishes a new game with one player or adds a second to a existing game
	*/
	public synchronized GameInterface registerPlayer(RemoteClientControlInterface playerRCC) throws RemoteException{
		try{
		game = (Game)gameList.lastElement();
 		System.out.println("GameServer.registerPlayer(): BEGIN");
		}
		catch(Exception a){
			game = new Game(this);
			gameList.addElement(game);}
		while(!game.registerPlayer(playerRCC)){
			System.out.println("GameServer.registerPlayer(): new Game() wird versucht da im alten Game bereits 2 Spieler sind");
			game = new Game(this);
			gameList.addElement(game);
			System.out.println("GameServer.registerPlayer(): new Game() erfolgreich");
			//nun registriere dieses newGame in der Liste
		}
		System.out.println("GameServer.registerPlayer(): END");
		
		return (GameInterface)game;
	}


	/**
	*The gameserver will delete gi from his list
	*/
	public void logout(GameInterface gi) throws RemoteException{
		gameList.removeElement(gi);
	} 

	/**
	*sends a message to all players
	*/
	public void sendMessage(String message, String sender) throws RemoteException{
		for(int i=0;i<gameList.size();i++){
			Game g = (Game)gameList.elementAt(i);
			(g.getPlayerA()).sendMessage(message,sender);
			(g.getPlayerB()).sendMessage(message,sender);
		}
	}


	/**
	*the mainmethod, starts the server 
	*/
	public static void main(String args[]){
		try{
			if(System.getSecurityManager()==null)
				System.setSecurityManager(new RMISecurityManager());
			System.out.println("GameServer: SecurityManager intalliert");
			GameServer gameServer = new GameServer();
						System.out.println("GameServer: Gamserver initialisiert");
			Naming.rebind("GameServer",gameServer);
			System.out.println("GameServer: erfolgreich bei Naming angemeldet");
			//for(;;);
		}
		catch(RemoteException e){System.out.print(e.toString());}
		catch(MalformedURLException e){System.out.print(e.toString());}

	}

}
