/**
*@ author Sebastian Seyrich, Markus Mattes
*/

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.net.URL;

/**
*The serverprogram: 
*A list of games will be established and administrated here
*/
public interface GameServerInterface extends Remote{

	/**
	*@ return a new game
	*establishes a new game with one player or adds a second to a existing game
	*/
	public GameInterface registerPlayer(RemoteClientControlInterface playerRCC) throws RemoteException; 


	/**
	*The gameserver will delete gi from his list
	*/
	public void logout(GameInterface gi) throws RemoteException; 

	/**
	*sends a message to all players
	*/
	public void sendMessage(String message, String dender) throws RemoteException;

}