/**
*@ author Sebastian Seyrich, Markus Mattes
*/

import java.awt.*;

/**
*This object writes a text into a component
*/
public class InfoCanvas extends AnotherCanvas{

    private String[][] line; //alle Zeilen eine Statische grsse, die alten werden berschrieben
    private String owner; //der Besitzer der Komponente
    private Color backColorA;
    private Color fontColor;
	private Color backColorB;
    private Font fontPlain;
    private Font fontBold;
	private FontMetrics fontMetricsPlain;
	private FontMetrics fontMetricsBold;                          
    private int fontMetricsSize; //die hoechste Hoehe der verwendeten Fonts
    private int counter;
	private int maxNameLength=0;
	private Dimension dim;
    
    public InfoCanvas(String _owner, Color _backColorA, Color _backColorB, Color _fontColor, Font _fontPlain, Font _fontBold){
		owner = _owner;
		backColorA = _backColorA;
		backColorB = _backColorB;
		fontColor = _fontColor;
		setBackground(Color.white);
		fontPlain = _fontPlain;
		fontBold = _fontBold;
		fontMetricsPlain = this.getFontMetrics(fontPlain);
		fontMetricsBold = this.getFontMetrics(fontPlain);
		if(fontMetricsPlain.getMaxAdvance()<fontMetricsBold.getMaxAdvance())
			fontMetricsSize = fontMetricsBold.getMaxAdvance();
		else
			fontMetricsSize = fontMetricsBold.getMaxAdvance();
		fontMetricsSize*=1.1; // 110% der Fonthoehe als Zeilenabstand
		line = new String[20][2];//rows*10][2];
		dim = new Dimension(780,fontMetricsSize*line.length);
		counter=0;
		setSize(dim);
    }
    
    /**
     *A message will be written to a new line
     */
    public void newLine(String sender,String message){
		line[counter%line.length][1] = message;
		if(fontMetricsBold.stringWidth(sender+":   ")>maxNameLength)
			maxNameLength = fontMetricsBold.stringWidth(sender+":   ");
		line[counter%line.length][0] = sender;
		counter++;
		repaint();
    }
    

    public void paint(Graphics g){
		g.setColor(fontColor);
		for(int i=0,j=0;i<line.length;i++){
			if(line[(i+counter)%line.length][1]!=null){
				if(owner.equals(line[(i+counter)%line.length][0]))
					g.setColor(backColorA);
				else
					g.setColor(backColorB);
				g.fillRect(1,j*fontMetricsSize+1,dim.width-2,fontMetricsSize-2);
				g.setFont(fontBold);
				g.setColor(fontColor);
				g.drawString(line[(i+counter)%line.length][0]+":",10,j*fontMetricsSize+3*fontMetricsSize/4);
				g.setFont(fontPlain);
				g.drawString(line[(i+counter)%line.length][1],maxNameLength+10,j*fontMetricsSize+3*fontMetricsSize/4);
				/*if(dim.width<(maxNameLength+10+fontMetricsPlain.stringWidth(line[(i+counter)%line.length][1]+" ")))
					dim.width= maxNameLength+10+fontMetricsPlain.stringWidth(line[(i+counter)%line.length][1]+" ");
				System.out.println(dim.width);
				setSize(dim);*/
				j++;
		    }
			g.setColor(Color.lightGray);				
			g.drawRect(1,i*fontMetricsSize,dim.width,fontMetricsSize-1);

		}
	
    }
    /**
     *Layoutmanager should not shrink the surounding container
     *to size 0x0 
     */
    public Dimension getMaximumSize(){
		return dim;
    }
    public Dimension getMinimumSize(){
		return dim;
    } 
    public Dimension getPreferredSizeSize(){
		return dim;
    } 
    

}
