/**
*@ author Sebastian Seyrich, Markus Mattes
*/

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.net.URL;


public class RemoteClientControl extends UnicastRemoteObject implements RemoteClientControlInterface{

	int x=0;
	private ClientPanel playerPanel;

	public RemoteClientControl(ClientPanel _playerPanel) throws RemoteException{
		super();
		playerPanel=_playerPanel;
	}


	/**
	*Object will draw the column again
	*/	
	public void updateColumn(int columnNumber, int[] column) throws RemoteException{
		playerPanel.updateColumn(columnNumber,column);
		System.out.println("updateColumn() aufgerufen");
	}

	/**
	*Activates and deactivates the calling object
	*Should activate and deactivate the input on the panel
	*/
	public void setActive(boolean b)  throws RemoteException{
		if(b)
			System.out.println("RemoteClientControl: "+playerPanel+", Sie sind aktiviert worden");
		else
			System.out.println("RemoteClientControl: "+playerPanel+", Sie sind deaktiviert worden");
		playerPanel.setActive(b);

	}

	/**
	*sends this object a message from sender
	*/
	public void sendMessage(String message, String sender) throws RemoteException{
		playerPanel.incomingMessage(message,sender);
	}

	/**
	*Tells the player about the finished game because of 
	* - opponent has logged out				4
	* - opponent is the winner				1
	* - opponent has lost the game			2
	* - there is no winner					0
	*/
	public void bye(int id) throws RemoteException{
		if (id == 4){
			System.out.println("Der Partner hat sich ausgeloggt, bitte beenden!");
			playerPanel.showInfo(4);
			//System.exit(0);	
		}
		if (id == 1){
			playerPanel.showInfo(1);
			System.out.println("You have lost this game, congratulations");
		}
		if (id == 2){
			playerPanel.showInfo(2);
			System.out.println("You have won this game, congratulations");
		}
		if (id == 0){
			playerPanel.showInfo(0);
			System.out.println("Bank wins evreything");
		}
	}

	/**
	*@ return the players name
	*/

	public String getName() throws RemoteException{
		return playerPanel.getName();
	}
} 