/**
*@ author Sebastian Seyrich, Markus Mattes
*/

import java.rmi.Remote;
import java.rmi.RemoteException;

public interface RemoteClientControlInterface extends Remote{


	/**
	*Object will draw the column again
	*/
	public void updateColumn(int columnNumber, int[] column) throws RemoteException;

	/**
	*Activates and deactivates the calling object
	*Should activate and deactivate the input on the panel
	*/
	public void setActive(boolean b)  throws RemoteException;

	/**
	*sends this object a message from sender
	*/
	public void sendMessage(String message, String sender) throws RemoteException;

	/**
	*Tells the player about the finished game because of 
	* - opponent has logged out				4
	* - opponent is the winner				1
	* - opponent has lost the game			2
	* - there is no winner					0
	*/
	public void bye(int id) throws RemoteException;


	/**
	*@ return the players name
	*/
	public String getName() throws RemoteException;

}